/*	dooroos : drv_rtc.c, v 0.1 2012-12-12 */

/*
 * Copyright (C) 2014	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: drv_rtc.c
 *
 * Purpose: 
 */

#include <types.h>
#include <thread.h>
#include <message.h>
#include <interrupt.h>
#include <window.h>
#include <time.h>
#include <device.h>
#include <error.h>

#include <mach/hal_interrupt.h>
#include <mach/SAMA5D3X.h>

#include <mach/gpio.h>

#include <hal_panic.h>

#include <dev/i2cdrv.h>
#include <dev/rtcdrv.h>


#define DBG_LVL_RTC			0

//==========================================================================
STATIC INT32                    th_RTCDevice( UINT32 Arg );

#define RTCDEV_STACK_SIZE       (512)
STATIC UINT32                   RTCDev_Stack[RTCDEV_STACK_SIZE>>2];

STATIC DEVICECONFIG             RTC_DeviceConfig ={"RTC", 0, -1, NULL, NULL };

PUBLIC THREADCONFIG             RTCDev_Thread =
                                            {
                                                (UINT32)&RTC_DeviceConfig,
                                                th_RTCDevice,
                                                (PBYTE)RTCDev_Stack,
                                                RTCDEV_STACK_SIZE,
                                                THREAD_PRIORITY_DRIVER_HIGH+4
                                            };
//==========================================================================

STATIC UINT32       Channel;
STATIC UINT32		gnSysIntr;

//==========================================================================

#define RTC8564_ADDRESS             (0xA2>>1)

#if 0

#define I2C_PIO_BASE                (AT91C_BASE_PIOA)
#define BIT_I2CSCL                  (AT91C_PIO_PC27)
#define BIT_I2CSDA                  (AT91C_PIO_PC26)


#define PIN_HOLD_0      0
#define PIN_OFF         1
    

static void DELAY( INT32 Cnt )
{
    volatile INT32   i;
    for( i = 0 ; i < Cnt*100;  )
    {
        i++;
    }
}

static void
SetSCL( BOOL bHigh )
{
#if 1
    I2C_PIO_BASE->PIO_OER = BIT_I2CSCL;
    I2C_PIO_BASE->PIO_PER = BIT_I2CSCL;

    /* Enable pull-up(s) if necessary */
    I2C_PIO_BASE->PIO_PPDDR = BIT_I2CSCL;
    I2C_PIO_BASE->PIO_PPUER = BIT_I2CSCL;

    I2C_PIO_BASE->PIO_MDER = BIT_I2CSCL; // open drain
    I2C_PIO_BASE->PIO_IFDR = BIT_I2CSCL;  // glitch

    if( bHigh == PIN_OFF )
        I2C_PIO_BASE->PIO_SODR = BIT_I2CSCL;
    else
        I2C_PIO_BASE->PIO_CODR = BIT_I2CSCL;
#else
    I2C_PIO_BASE->PIO_MDER = BIT_I2CSCL;
    I2C_PIO_BASE->PIO_IFDR = BIT_I2CSCL;
    if( bHigh == PIN_OFF )
    {
        I2C_PIO_BASE->PIO_SODR = BIT_I2CSCL;   // set to 1

    }
    else
    {
        I2C_PIO_BASE->PIO_CODR = BIT_I2CSCL;   // set to 0
        
    }
        I2C_PIO_BASE->PIO_OER = BIT_I2CSCL;    //  output
        I2C_PIO_BASE->PIO_PER = BIT_I2CSCL;
#endif
    return;
}

static void
SetSDA( BOOL bHigh )
{
#if 1
    I2C_PIO_BASE->PIO_OER = BIT_I2CSDA;
    I2C_PIO_BASE->PIO_PER = BIT_I2CSDA;

    /* Enable pull-up(s) if necessary */
    I2C_PIO_BASE->PIO_PPDDR = BIT_I2CSDA;
    I2C_PIO_BASE->PIO_PPUER = BIT_I2CSDA;

    I2C_PIO_BASE->PIO_MDER = BIT_I2CSDA; // open drain
    I2C_PIO_BASE->PIO_IFDR = BIT_I2CSDA;  // glitch

    if( bHigh == PIN_OFF )
        I2C_PIO_BASE->PIO_SODR = BIT_I2CSDA;
    else
        I2C_PIO_BASE->PIO_CODR = BIT_I2CSDA;
#else
    if( bHigh == PIN_OFF )
    {
        /* Enable pull-up(s) i*/
        I2C_PIO_BASE->PIO_PPDDR = BIT_I2CSDA;
        I2C_PIO_BASE->PIO_PUER = BIT_I2CSDA;
        I2C_PIO_BASE->PIO_MDER = BIT_I2CSDA;

        // glitch
        I2C_PIO_BASE->PIO_IFDR = BIT_I2CSDA;

        /* Configure pin as input */
        I2C_PIO_BASE->PIO_ODR = BIT_I2CSDA;
        I2C_PIO_BASE->PIO_PER = BIT_I2CSDA;
    }
    else
    {
        I2C_PIO_BASE->PIO_CODR = BIT_I2CSDA;   // set to 0
        
        I2C_PIO_BASE->PIO_OER = BIT_I2CSDA;    //  output
        I2C_PIO_BASE->PIO_PER = BIT_I2CSDA;
    }
#endif
    return;
}


static void
Start_I2C( void )
{
//test();
        SetSCL(PIN_OFF);
        SetSDA(PIN_OFF);

    DELAY(10);
        SetSDA(PIN_HOLD_0);
    DELAY(30);
        SetSCL(PIN_HOLD_0);
    DELAY(20);
}

static void
Stop_I2C( void )
{
//        SetSCL(PIN_HOLD_0);
//        SetSDA(PIN_HOLD_0);
//    DELAY( 20 );
        SetSCL(PIN_OFF);
    DELAY( 20 );
        SetSDA(PIN_OFF);
    DELAY(20);
    
}


static BYTE
Read_I2C_Data( void )
{
    BYTE Data = 0;
    UINT16 wClockCnt=0;
    //UINT16 wBitPointer=0;
    //INT32 Count=0;

        //SetSDA(PIN_HOLD_0);  // 
        //SetSCL(PIN_HOLD_0);
        //DELAY(20);

        SetSDA(PIN_OFF);  // input
    for(wClockCnt = 0; wClockCnt < 8; wClockCnt++)
    {
        DELAY(50);
            SetSCL(PIN_OFF);

        DELAY(30);

        Data <<= 1;
//printf("PIO_PDSR= 0x%0.8x\r\n",I2C_PIO_BASE->PIO_PDSR );
        if( (I2C_PIO_BASE->PIO_PDSR & BIT_I2CSDA) == BIT_I2CSDA )
            Data |= 1;

        DELAY(20);
        
            SetSCL(PIN_HOLD_0);
        DELAY(20);
    }
    
    // SEND ACK
        SetSDA(PIN_HOLD_0);
    DELAY(50);
        SetSCL(PIN_OFF);
    DELAY(30);
        SetSCL(PIN_HOLD_0);
    DELAY(20);


//        SetSDA(PIN_OFF);
    
    return Data;
}

static BOOL
Write_I2C_Data( BYTE Data )
{
    UINT16 wClockCnt=0, wBitPointer=0;
    INT32 Count=0;
    wBitPointer=0x80;

    
        SetSDA(PIN_HOLD_0);
        SetSCL(PIN_HOLD_0);
        DELAY(30);

    for(wClockCnt = 0; wClockCnt < 8; wClockCnt++)
    {
        if(Data & (BYTE)wBitPointer)
            SetSDA(PIN_OFF);
        else
            SetSDA(PIN_HOLD_0);

        DELAY(10);
            SetSCL(PIN_OFF);
        DELAY(30);
            SetSCL(PIN_HOLD_0);
        DELAY(20);
        wBitPointer >>= 1;
    }

        SetSDA(PIN_OFF); // data in
    DELAY( 20 );
        SetSCL(PIN_OFF);
    DELAY( 20 );
    //while( AT91F_PIO_IsInputSet(I2C_PIO_BASE, BIT_I2CSDA) )
    while( (I2C_PIO_BASE->PIO_PDSR & BIT_I2CSDA) )
    {
        Count++;
        if(Count >= 1000)
        {
            // stop
            Stop_I2C();
            return FALSE;
        }
        DELAY( 1 );
    }

        SetSCL(PIN_HOLD_0);
    //DELAY( 20 );
    //AT91F_PIO_ClearOutput( I2C_PIO_BASE, BIT_I2CSCL );
    DELAY(50 );
    return TRUE;
}







STATIC VOID
TWID_Write( BYTE Addr, UINT32 Reg, BYTE Size, PBYTE pData, UINT32 Num )
{
    BOOL ret1,ret2,ret3;
    int timeout = 0;
//kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, Reg, Val );
do
{
    Start_I2C();

    ret1 = Write_I2C_Data( (Addr<<1)|0 );
    ret2 = Write_I2C_Data( Reg );

    int i;
    for( i = 0; i < Num; i++ )
    {
        BYTE    Val = *pData;
        ret3 = Write_I2C_Data( Val );
    }

    Stop_I2C();
//kprintf( "%s ret (%x , %x , %x)\n",__FUNCTION__,ret1,ret2,ret3 );

    if( timeout++ >= 5)
        break;

}while( !ret1 || !ret2 || !ret3 );
 
}

STATIC VOID
TWID_Read( BYTE Addr, UINT32 Reg, BYTE Size, PBYTE pData, UINT32 Num )
{
    BOOL ret1,ret2,ret3;
    int timeout = 0;

do
{
    Start_I2C();
    ret1 = Write_I2C_Data( (Addr<<1) | 0);
    ret2 = Write_I2C_Data( Reg );
    Stop_I2C();
Sleep(10);
    Start_I2C();
    ret3 = Write_I2C_Data( (Addr<<1) | 1);
//    ret2 = Write_I2C_Data( Reg );
DELAY(200);
    int i;
    for( i = 0; i < Num; i++ )
    {
        *pData = Read_I2C_Data(  );
    }
    Stop_I2C();
//kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, Reg, *pData );
//kprintf("%s ret (%x , %x, %x)\n",__FUNCTION__,ret1,ret2, ret3 );
    if( timeout++ >= 5)
        break;
}while(!ret1 || !ret2 || !ret3);

}

#else
STATIC HANDLE   hI2C = NULL;

STATIC VOID
TWID_Write( BYTE Addr, UINT32 Reg, BYTE Size, PBYTE pData, UINT32 Num )
{
    BOOL    bRet;

    TWI_IO_DESC TwiIoDesc;

    TwiIoDesc.SlaveAddress = Addr;
    TwiIoDesc.PageSize = 0;
    TwiIoDesc.Delay = 1;
    TwiIoDesc.InterSize = Size/8;
    TwiIoDesc.InterAddress = Reg;
    TwiIoDesc.Count = Num;
    TwiIoDesc.pData = pData;
    
    bRet = IoControl( hI2C, IOCTRL_IIC_MASTER_WRITE, &TwiIoDesc, sizeof(TWI_IO_DESC), NULL, NULL);

}

STATIC VOID
TWID_Read( BYTE Addr, UINT32 Reg, BYTE Size, PBYTE pData, UINT32 Num )
{
    BOOL    bRet;
    TWI_IO_DESC TwiIoDesc;

//kprintf("%s(%d): Reg = %2.2x \n",__FUNCTION__,__LINE__, Reg);

    TwiIoDesc.SlaveAddress = Addr;
    TwiIoDesc.PageSize = 0;
    TwiIoDesc.Delay = 1;
    TwiIoDesc.InterSize = 1;
    TwiIoDesc.InterAddress = Reg;
    TwiIoDesc.Count = Num;
    TwiIoDesc.pData = pData;
    
    bRet = IoControl( hI2C, IOCTRL_IIC_MASTER_READ, &TwiIoDesc, sizeof(TWI_IO_DESC), NULL, NULL);

    return;
}

#endif

#define CONTROL1_REG            0
#define CONTROL2_REG            1
#define SECONDS_REG             2
#define MINUTES_REG             3
#define HOURS_REG               4
#define DAYS_REG                5
#define WEEKDAYS_REG            6
#define MONTH_CENTURY_REG       7
#define YEARS_REG               8
#define MINUTE_ALARM_REG        9
#define HOUR_ALARM_REG          10
#define DAY_ALARM_REG           11
#define WEEKDAY_ALARM_REG       12
#define CLKOUT_FREQ_REG         13
#define TIMER_CONTROL_REG       14
#define TIMER_REG               15


#define BCD_TO_HEX( b )     (((b)>>4)*10 + (b&0x0F))
#define HEX_TO_BCD( h )     ((((h)/10)<<4) + (h)%10)
STATIC BOOL RTC_SetTime(HUMANTIME *pHumanTime )
{
    BOOL    bRet = TRUE;

    BYTE    RTCData[YEARS_REG + 1];

    memset( RTCData, 0, YEARS_REG + 1);

    // 
    RTCData[MONTH_CENTURY_REG] = HEX_TO_BCD(pHumanTime->Month);
    if( pHumanTime->Year >= 2000 )
        RTCData[MONTH_CENTURY_REG] |= 0x80;

    RTCData[YEARS_REG] = HEX_TO_BCD(pHumanTime->Year % 100);

    RTCData[DAYS_REG] = HEX_TO_BCD(pHumanTime->Day);
    RTCData[HOURS_REG] = HEX_TO_BCD(pHumanTime->Hour);
    RTCData[MINUTES_REG] = HEX_TO_BCD(pHumanTime->Minute);
    RTCData[SECONDS_REG] = HEX_TO_BCD(pHumanTime->Second);

    int i;
    for( i = 0; i< YEARS_REG + 1 ;i++ )
    {
        TWID_Write( RTC8564_ADDRESS, CONTROL1_REG + i, 8, RTCData + i, 1 );
    }
    //TWID_Write( RTC8564_ADDRESS, CONTROL1_REG, 8, RTCData, YEARS_REG + 1 );

    return bRet;
}

STATIC BOOL RTC_GetTime( HUMANTIME *pHumanTime )
{
    BOOL    bRet = TRUE;
    BYTE    RTCData[YEARS_REG + 1];

    int i;
    for( i = 0; i< YEARS_REG + 1 ;i++ )
    {
        TWID_Read( RTC8564_ADDRESS, CONTROL1_REG + i, 8, RTCData + i, 1 );
    }
    //TWID_Read( RTC8564_ADDRESS, CONTROL1_REG, 8, RTCData, YEARS_REG + 1 );

    pHumanTime->Month = BCD_TO_HEX(RTCData[MONTH_CENTURY_REG] & 0x1F);

    if( RTCData[MONTH_CENTURY_REG] & 0x80 ) // century
        pHumanTime->Year = 2000;
    else
        pHumanTime->Year = 1900;
    pHumanTime->Year += BCD_TO_HEX(RTCData[YEARS_REG]);

    pHumanTime->Day = BCD_TO_HEX(RTCData[DAYS_REG] & 0x3F);
    pHumanTime->Hour = BCD_TO_HEX(RTCData[HOURS_REG] & 0x3F);
    pHumanTime->Minute = BCD_TO_HEX(RTCData[MINUTES_REG] & 0x7F);
    pHumanTime->Second = BCD_TO_HEX(RTCData[SECONDS_REG] & 0x7F);
    
    pHumanTime->DayOfWeek = RTCData[WEEKDAYS_REG] & 0x07;

kprintf("%s(%d): %d, %d, %d, %d, %d, %d (%d)\n",__FUNCTION__,__LINE__,
                                                pHumanTime->Year,
                                                pHumanTime->Month,
                                                pHumanTime->Day,
                                                pHumanTime->Hour,
                                                pHumanTime->Minute,
                                                pHumanTime->Second,
                                                pHumanTime->DayOfWeek
                                                );

    return bRet;
}


STATIC VOID
RTCInit( VOID )
{
    BOOL    bRead = FALSE;

    BYTE Data = 0;
    TWID_Write( RTC8564_ADDRESS, CONTROL1_REG, 8, &Data, 1 );

#if 0
    for( ;; )
    {
#if 1
        HUMANTIME   HumanTime;
        if( bRead )
        {
            RTC_GetTime( &HumanTime );

            SYSTEMTIME  SystemTime;
            HumanTimeToSystemTime( &HumanTime, &SystemTime );
            TimeSet( &SystemTime );
kprintf("%s(%d): SystemTime = %x\n",__FUNCTION__,__LINE__,(UINT32)SystemTime.LoTime );

            TimeGet( &SystemTime );
kprintf("%s(%d): SystemTime = %x\n",__FUNCTION__,__LINE__,(UINT32)SystemTime.LoTime );
            SystemTimeToHumanTime( &SystemTime, &HumanTime );
kprintf("%s(%d): %d, %d, %d, %d, %d, %d (%d)\n",__FUNCTION__,__LINE__,
                                                HumanTime.Year,
                                                HumanTime.Month,
                                                HumanTime.Day,
                                                HumanTime.Hour,
                                                HumanTime.Minute,
                                                HumanTime.Second,
                                                HumanTime.DayOfWeek
                                                );
        }
        else
        {
            if( HumanTime.Year < 2000 )
                HumanTime.Year = 2000;
            else
                HumanTime.Year++;

            HumanTime.Month++;
            HumanTime.Day++;
            HumanTime.Hour++;
            HumanTime.Minute++;
            RTC_SetTime( &HumanTime );
        }
#else
        if( bRead )
        {
            BYTE Data = 0;
            TWID_Read( RTC8564_ADDRESS, CONTROL1_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, CONTROL1_REG, Data );
            TWID_Read( RTC8564_ADDRESS, SECONDS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, SECONDS_REG, Data );
            TWID_Read( RTC8564_ADDRESS, MINUTES_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, MINUTES_REG, Data );
            TWID_Read( RTC8564_ADDRESS, HOURS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, HOURS_REG, Data );
            TWID_Read( RTC8564_ADDRESS, DAYS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, DAYS_REG, Data );
            TWID_Read( RTC8564_ADDRESS, WEEKDAYS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, WEEKDAYS_REG, Data );
            TWID_Read( RTC8564_ADDRESS, MONTH_CENTURY_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, MONTH_CENTURY_REG, Data );
            TWID_Read( RTC8564_ADDRESS, YEARS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, YEARS_REG, Data );
        }
        else
        {
            BYTE Data = 0;
            TWID_Write( RTC8564_ADDRESS, CONTROL1_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, CONTROL1_REG, Data );
/*
            TWID_Write( RTC8564_ADDRESS, SECONDS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, SECONDS_REG, Data );
            TWID_Write( RTC8564_ADDRESS, MINUTES_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, MINUTES_REG, Data );
            TWID_Write( RTC8564_ADDRESS, HOURS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, HOURS_REG, Data );
            TWID_Write( RTC8564_ADDRESS, DAYS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, DAYS_REG, Data );
            TWID_Write( RTC8564_ADDRESS, WEEKDAYS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, WEEKDAYS_REG, Data );
            TWID_Write( RTC8564_ADDRESS, MONTH_CENTURY_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, MONTH_CENTURY_REG, Data );
            TWID_Write( RTC8564_ADDRESS, YEARS_REG, 8, &Data, 1 );
kprintf("%s(%d):Reg = 0x%2.2x, Val = 0x%2.2x\n",__FUNCTION__,__LINE__, YEARS_REG, Data );
*/
        }
#endif
        bRead = !bRead;
        Sleep(3000);
    }
#endif
	return;
}

/*
  Name: th_RTCDevice()
  Copyright: 
  Author: jung byoung oh
  Description: rtc device thread
  Command:

*/
STATIC INT32
th_RTCDevice( UINT32 Arg )
{
	JB_RECVMESSAGE      Message;
    HANDLE              hPort;
	HANDLE              Handle = NULL;
	SYSINTR_REQUEST		SysIntrRequest;
	UINT32				nSysIntr = 0;
	
    hPort = PortGet( );    
    PortSetType(hPort, PORTTYPE_MESSAGE|/*PORTTYPE_INTERRUPT|*/PORTTYPE_SIGNAL);

    RTC_DeviceConfig.Name[3] = (UINT32)RTC_DeviceConfig.Minor + '1';
    RTC_DeviceConfig.Channel = Channel = ChannelGet( hPort );

    DeviceRegister( &RTC_DeviceConfig );

    hI2C = IoOpen( (PBYTE)"I2C2" );
//    kprintf("%s(%d): hI2C = %x\n",__FUNCTION__, __LINE__, hI2C);

    
    RTCInit();

	while(1)
	{
		MessageReceive( hPort, &Message);

		switch(Message.Type)
		{

        case MESSAGE_TYPE_INTERRUPT:
        {
            continue;
        }
        case MESSAGE_TYPE_SIGNAL:
		{
            continue;
        }

		case MESSAGE_TYPE_DEVICE_CONTROL:
	    {
            if( Handle == NULL || Message.Handle != Handle )
            {
                ThreadSetLastError( Message.hSender, ERR_INVALID_HANDLE );
                Message.Type = FALSE;
                break;
            }

            PIOCONTROL_PARAM    pIoControlParam;
            pIoControlParam = (PIOCONTROL_PARAM)Message.Param;
		    switch( pIoControlParam->Cmd )
		    {
		    case IOCTRL_READ_RTC:
            {
                HUMANTIME   HumanTime;
                if( pIoControlParam->pOutBuf == NULL ||
                    pIoControlParam->pnOut  == NULL ||
                    *pIoControlParam->pnOut < sizeof(HUMANTIME) )
                {
                    Message.Type = FALSE;
                    break;
                }
				RTC_GetTime( &HumanTime );
                *(HUMANTIME *)pIoControlParam->pOutBuf = HumanTime;
				break;
            }
		    case IOCTRL_WRITE_RTC:
            {
                HUMANTIME   HumanTime;
                if( pIoControlParam->pInBuf == NULL ||
                    pIoControlParam->nIn < sizeof(HUMANTIME) )
                {
                    Message.Type = FALSE;
                    break;
                }
                HumanTime = *(HUMANTIME *)pIoControlParam->pInBuf;
				RTC_SetTime( &HumanTime );
                Message.Type = TRUE;
				break;
		    }
            default:
				break;
			}
            Message.Type = TRUE;
			break;
	    }
		case MESSAGE_TYPE_DEVICE_OPEN:
        {
			Handle = ChannelOpenHandleGetFrom(Channel);
			Message.Type = Handle;
            break;
        }

		case MESSAGE_TYPE_DEVICE_CLOSE:
        {
		    Handle = NULL;
		    Message.Type = TRUE;
			break;
	    }

		default:
            Message.Type = 0;
			break;
		}

		MessageReply( &Message );
	}

	return TRUE;	
}



#include <moduleloader.h>

PUBLIC BOOL
DllMain( HANDLE hDll, UINT32 Reason, PVOID Reserved )
{
    switch( Reason )
    {
    case DLL_PROCESS_ATTACH:
        ThreadCreate (&RTCDev_Thread);
    	break;
    
    case DLL_PROCESS_DETACH:
    	break;
    }

    return hDll;
}






